"use strict";
/**
 * @license
 *
 * JavaScriptBridge 0.5.3
 *
 * Copyright (c) 2017-2018, Shoal Games Ltd.
 *
 * Permission to use, copy, modify, and/or distribute this software for any
 * purpose with or without fee is hereby granted, provided that the above
 * copyright notice and this permission notice appear in all copies.
 *
 * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
 * REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
 * INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
 * LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE
 * OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
 * PERFORMANCE OF THIS SOFTWARE.
 */
var JavaScriptBridge=function(){function JavaScriptBridge(e){this._prefix="";this._counter=0;this._isEnabled=true;this._sendQueue=[];this._queue={};this._handlers={};this._prefix=e;this.SendDelegate=function(e){}}Object.defineProperty(JavaScriptBridge.prototype,"Name",{get:function(){return this._prefix},enumerable:true,configurable:true});Object.defineProperty(JavaScriptBridge.prototype,"IsEnabled",{get:function(){return this._isEnabled},set:function(e){if(e===this._isEnabled){return}this._isEnabled=e;if(this._isEnabled){this.Pump()}},enumerable:true,configurable:true});JavaScriptBridge.prototype.SetHandler=function(e,t){this._handlers[e]=t};JavaScriptBridge.prototype.SendCallRequest=function(e,t,i){if(e===undefined){return}var r=this.NextId();var n=i!==undefined;if(n){var a={id:r,callback:i};this._queue[a.id]=a}var s={source:this._prefix,id:r,method:e,parameters:t,hasResult:n};this.DoSend(s)};JavaScriptBridge.prototype.Reset=function(){this._counter=0;this._queue={};this.ClearSendQueue()};JavaScriptBridge.prototype.ClearSendQueue=function(){this._sendQueue.length=0};JavaScriptBridge.prototype.Pump=function(){while(this.IsEnabled&&this._sendQueue.length>0){var e=this._sendQueue.shift();if(e===undefined){continue}this.SendDelegate(e)}};JavaScriptBridge.prototype.SendCallResponse=function(e,t,i){var r={source:this._prefix,id:e.id,result:t,error:i};this.DoSend(r)};JavaScriptBridge.prototype.HandleCallRequest=function(e){var t=this._handlers[e.method];if(t===undefined){this.SendCallResponse(e,undefined,"no-handler")}else{var i=t.apply(void 0,e.parameters);if(e.hasResult===true){this.SendCallResponse(e,i,undefined)}}};JavaScriptBridge.prototype.HandleCallResponse=function(e){var t=this._queue[e.id];if(t===undefined){return}if(t.callback){t.callback(e.result,e.error)}this._queue[e.id]=undefined};JavaScriptBridge.prototype.DoSend=function(e){var t=""+this._prefix+JSON.stringify(e);if(!this.IsEnabled){this._sendQueue.push(t);return}this.SendDelegate(t)};JavaScriptBridge.prototype.DoReceive=function(e){if(typeof e!=="string"){return}if(e.indexOf(this._prefix)!==-1){return}var t=e.indexOf("{");if(t<=0){return}var i=e.substr(t);var r=JSON.parse(i);if(r.method===undefined){this.HandleCallResponse(r)}else{this.HandleCallRequest(r)}};JavaScriptBridge.prototype.NextId=function(){this._counter+=1;return this._counter};return JavaScriptBridge}();var JavaScriptBridgeFactory=function(){function JavaScriptBridgeFactory(){}JavaScriptBridgeFactory.Create=function(e,t){if(e===void 0){e="client"}if(t===void 0){t="*"}var i=new JavaScriptBridge(e);i.IsEnabled=false;i.SendDelegate=function(e){window.top.postMessage(e,t)};i.SetHandler("init",function(){i.IsEnabled=true});i.SetHandler("deinit",function(){i.IsEnabled=false;i.Reset()});window.addEventListener("message",function(e){var t=e.data;i.DoReceive(t)},false);document.addEventListener("message",function(e){var t=e.data;i.DoReceive(t)},false);return i};return JavaScriptBridgeFactory}();